diff --git a/libgcc/config/libbid/bid64_div.c b/libgcc/config/libbid/bid64_div.c
old mode 100644
new mode 100755
index 69758482b89..7f34556c6d6
--- a/libgcc/config/libbid/bid64_div.c
+++ b/libgcc/config/libbid/bid64_div.c
@@ -55,9 +55,8 @@ see the files COPYING3 and COPYING.RUNTIME respectively.  If not, see
 
 #include "bid_internal.h"
 #include "bid_div_macros.h"
-#ifdef UNCHANGED_BINARY_STATUS_FLAGS
 #include <fenv.h>
-
+#ifdef UNCHANGED_BINARY_STATUS_FLAGS
 #define FE_ALL_FLAGS FE_INVALID|FE_DIVBYZERO|FE_OVERFLOW|FE_UNDERFLOW|FE_INEXACT
 #endif
 
@@ -65,7 +64,6 @@ extern UINT32 convert_table[5][128][2];
 extern SINT8 factors[][2];
 extern UINT8 packed_10000_zeros[];
 
-
 #if DECIMAL_CALL_BY_REFERENCE
 
 void
@@ -94,6 +92,7 @@ bid64_div (UINT64 x,
   int rmode, amount;
   int nzeros, i, j, k, d5;
   UINT32 QX32, tdigit[3], digit, digit_h, digit_low;
+  int old_rm, rm_changed=0;
 #ifdef UNCHANGED_BINARY_STATUS_FLAGS
   fexcept_t binaryflags = 0;
 #endif
@@ -106,6 +105,12 @@ bid64_div (UINT64 x,
   y = *py;
 #endif
 
+  // Set it to round-to-nearest (if different)
+  if ((old_rm=fegetround()) != FE_TONEAREST) {
+    rm_changed=1;
+    fesetround(FE_TONEAREST);
+  }
+
   valid_x = unpack_BID64 (&sign_x, &exponent_x, &coefficient_x, x);
   valid_y = unpack_BID64 (&sign_y, &exponent_y, &coefficient_y, y);
 
@@ -123,6 +128,8 @@ bid64_div (UINT64 x,
       if ((x & SNAN_MASK64) == SNAN_MASK64)	// sNaN
 	__set_status_flags (pfpsf, INVALID_EXCEPTION);
 #endif
+      // restore the rounding mode back if it has been changed
+      if (rm_changed) fesetround(old_rm);
       BID_RETURN (coefficient_x & QUIET_MASK64);
     }
     // x is Infinity?
@@ -134,10 +141,14 @@ bid64_div (UINT64 x,
 #ifdef SET_STATUS_FLAGS
 	  __set_status_flags (pfpsf, INVALID_EXCEPTION);
 #endif
+          // restore the rounding mode back if it has been changed
+          if (rm_changed) fesetround(old_rm);
 	  BID_RETURN (NAN_MASK64);
 	}
       } else {
 	// otherwise return +/-Inf
+        // restore the rounding mode back if it has been changed
+        if (rm_changed) fesetround(old_rm);
 	BID_RETURN (((x ^ y) & 0x8000000000000000ull) |
 		    INFINITY_MASK64);
       }
@@ -149,6 +160,8 @@ bid64_div (UINT64 x,
 #ifdef SET_STATUS_FLAGS
       __set_status_flags (pfpsf, INVALID_EXCEPTION);
 #endif
+      // restore the rounding mode back if it has been changed
+      if (rm_changed) fesetround(old_rm);
       BID_RETURN (NAN_MASK64);
     }
     if (((y & INFINITY_MASK64) != INFINITY_MASK64)) {
@@ -163,6 +176,8 @@ bid64_div (UINT64 x,
 	exponent_x = DECIMAL_MAX_EXPON_64;
       else if (exponent_x < 0)
 	exponent_x = 0;
+      // restore the rounding mode back if it has been changed
+      if (rm_changed) fesetround(old_rm);
       BID_RETURN ((sign_x ^ sign_y) | (((UINT64) exponent_x) << 53));
     }
 
@@ -176,17 +191,23 @@ bid64_div (UINT64 x,
       if ((y & SNAN_MASK64) == SNAN_MASK64)	// sNaN
 	__set_status_flags (pfpsf, INVALID_EXCEPTION);
 #endif
+      // restore the rounding mode back if it has been changed
+      if (rm_changed) fesetround(old_rm);
       BID_RETURN (coefficient_y & QUIET_MASK64);
     }
     // y is Infinity?
     if ((y & INFINITY_MASK64) == INFINITY_MASK64) {
       // return +/-0
+      // restore the rounding mode back if it has been changed
+      if (rm_changed) fesetround(old_rm);
       BID_RETURN (((x ^ y) & 0x8000000000000000ull));
     }
     // y is 0
 #ifdef SET_STATUS_FLAGS
     __set_status_flags (pfpsf, ZERO_DIVIDE_EXCEPTION);
 #endif
+    // restore the rounding mode back if it has been changed
+    if (rm_changed) fesetround(old_rm);
     BID_RETURN ((sign_x ^ sign_y) | INFINITY_MASK64);
   }
 #ifdef UNCHANGED_BINARY_STATUS_FLAGS
@@ -255,6 +276,8 @@ bid64_div (UINT64 x,
 #ifdef UNCHANGED_BINARY_STATUS_FLAGS
       (void) fesetexceptflag (&binaryflags, FE_ALL_FLAGS);
 #endif
+      // restore the rounding mode back if it has been changed
+      if (rm_changed) fesetround(old_rm);
       BID_RETURN (res);
     }
     // get decimal digits of Q
@@ -424,6 +447,8 @@ bid64_div (UINT64 x,
 #ifdef UNCHANGED_BINARY_STATUS_FLAGS
       (void) fesetexceptflag (&binaryflags, FE_ALL_FLAGS);
 #endif
+      // restore the rounding mode back if it has been changed
+      if (rm_changed) fesetround(old_rm);
       BID_RETURN (res);
     }
   }
@@ -494,6 +519,8 @@ bid64_div (UINT64 x,
 #ifdef UNCHANGED_BINARY_STATUS_FLAGS
     (void) fesetexceptflag (&binaryflags, FE_ALL_FLAGS);
 #endif
+    // restore the rounding mode back if it has been changed
+    if (rm_changed) fesetround(old_rm);
     BID_RETURN (res);
   } else {
     // UF occurs
@@ -510,6 +537,8 @@ bid64_div (UINT64 x,
 #ifdef UNCHANGED_BINARY_STATUS_FLAGS
     (void) fesetexceptflag (&binaryflags, FE_ALL_FLAGS);
 #endif
+    // restore the rounding mode back if it has been changed
+    if (rm_changed) fesetround(old_rm);
     BID_RETURN (res);
 
   }
@@ -528,10 +557,17 @@ int exponent_x, exponent_y, bin_index, bin_expon, diff_expon, ed2,
   digits_q, amount;
 int nzeros, i, j, k, d5, done = 0;
 unsigned rmode;
+int old_rm, rm_changed=0;
 #ifdef UNCHANGED_BINARY_STATUS_FLAGS
 fexcept_t binaryflags = 0;
 #endif
 
+// Set it to round-to-nearest (if different)
+if ((old_rm=fegetround()) != FE_TONEAREST) {
+  rm_changed=1;
+  fesetround(FE_TONEAREST);
+}
+
 valid_y = unpack_BID128_value (&sign_y, &exponent_y, &CY, y);
 
 	// unpack arguments, check for NaN or Infinity
@@ -545,6 +581,8 @@ if (!unpack_BID64 (&sign_x, &exponent_x, &CX.w[0], (x))) {
   // test if x is NaN
   if (((x) & 0x7c00000000000000ull) == 0x7c00000000000000ull) {
     res = CX.w[0];
+    // restore the rounding mode back if it has been changed
+    if (rm_changed) fesetround(old_rm);
     BID_RETURN (res & QUIET_MASK64);
   }
   // x is Infinity?
@@ -557,14 +595,18 @@ if (!unpack_BID64 (&sign_x, &exponent_x, &CX.w[0], (x))) {
       __set_status_flags (pfpsf, INVALID_EXCEPTION);
 #endif
       res = 0x7c00000000000000ull;
+      // restore the rounding mode back if it has been changed
+      if (rm_changed) fesetround(old_rm);
+      BID_RETURN (res);
+    }
+    if (((y.w[1] & 0x7c00000000000000ull) != 0x7c00000000000000ull)) {
+      // otherwise return +/-Inf
+      res =
+	(((x) ^ y.w[1]) & 0x8000000000000000ull) | 0x7800000000000000ull;
+      // restore the rounding mode back if it has been changed
+      if (rm_changed) fesetround(old_rm);
       BID_RETURN (res);
     }
-	if (((y.w[1] & 0x7c00000000000000ull) != 0x7c00000000000000ull)) {
-    // otherwise return +/-Inf
-    res =
-      (((x) ^ y.w[1]) & 0x8000000000000000ull) | 0x7800000000000000ull;
-    BID_RETURN (res);
-	}
   }
   // x is 0
   if ((y.w[1] & INFINITY_MASK64) != INFINITY_MASK64) {
@@ -574,6 +616,8 @@ if (!unpack_BID64 (&sign_x, &exponent_x, &CX.w[0], (x))) {
 #endif
       // x=y=0, return NaN
       res = 0x7c00000000000000ull;
+      // restore the rounding mode back if it has been changed
+      if (rm_changed) fesetround(old_rm);
       BID_RETURN (res);
     }
     // return 0
@@ -584,6 +628,8 @@ if (!unpack_BID64 (&sign_x, &exponent_x, &CX.w[0], (x))) {
     else if (exponent_x < 0)
       exponent_x = 0;
     res |= (((UINT64) exponent_x) << 53);
+    // restore the rounding mode back if it has been changed
+    if (rm_changed) fesetround(old_rm);
     BID_RETURN (res);
   }
 }
@@ -604,12 +650,16 @@ if (!valid_y) {
     amount = recip_scale[18];
     __shr_128 (Tmp, Qh, amount);
     res = (CY.w[1] & 0xfc00000000000000ull) | Tmp.w[0];
+    // restore the rounding mode back if it has been changed
+    if (rm_changed) fesetround(old_rm);
     BID_RETURN (res);
   }
   // y is Infinity?
   if ((y.w[1] & 0x7800000000000000ull) == 0x7800000000000000ull) {
     // return +/-0
     res = sign_x ^ sign_y;
+    // restore the rounding mode back if it has been changed
+    if (rm_changed) fesetround(old_rm);
     BID_RETURN (res);
   }
   // y is 0, return +/-Inf
@@ -618,6 +668,8 @@ if (!valid_y) {
 #ifdef SET_STATUS_FLAGS
   __set_status_flags (pfpsf, ZERO_DIVIDE_EXCEPTION);
 #endif
+  // restore the rounding mode back if it has been changed
+  if (rm_changed) fesetround(old_rm);
   BID_RETURN (res);
 }
 #ifdef UNCHANGED_BINARY_STATUS_FLAGS
@@ -680,6 +732,8 @@ if (__unsigned_compare_gt_128 (CY, CX)) {
 #ifdef UNCHANGED_BINARY_STATUS_FLAGS
       (void) fesetexceptflag (&binaryflags, FE_ALL_FLAGS);
 #endif
+      // restore the rounding mode back if it has been changed
+      if (rm_changed) fesetround(old_rm);
       BID_RETURN (res);
     }
 
@@ -816,15 +870,17 @@ if (!done) {
 
       }
     }
-	if(diff_expon>=0){
-    res =
-      fast_get_BID64_check_OF (sign_x ^ sign_y, diff_expon, CQ.w[0],
-			       rnd_mode, pfpsf);
+    if(diff_expon>=0){
+      res =
+	fast_get_BID64_check_OF (sign_x ^ sign_y, diff_expon, CQ.w[0],
+				 rnd_mode, pfpsf);
 #ifdef UNCHANGED_BINARY_STATUS_FLAGS
     (void) fesetexceptflag (&binaryflags, FE_ALL_FLAGS);
 #endif
-    BID_RETURN (res);
-	}
+      // restore the rounding mode back if it has been changed
+      if (rm_changed) fesetround(old_rm);
+      BID_RETURN (res);
+    }
   }
 #endif
 
@@ -905,6 +961,8 @@ if (!done) {
 #ifdef UNCHANGED_BINARY_STATUS_FLAGS
     (void) fesetexceptflag (&binaryflags, FE_ALL_FLAGS);
 #endif
+    // restore the rounding mode back if it has been changed
+    if (rm_changed) fesetround(old_rm);
     BID_RETURN (res);
   } else {
     // UF occurs
@@ -921,8 +979,9 @@ if (!done) {
 #ifdef UNCHANGED_BINARY_STATUS_FLAGS
     (void) fesetexceptflag (&binaryflags, FE_ALL_FLAGS);
 #endif
+    // restore the rounding mode back if it has been changed
+    if (rm_changed) fesetround(old_rm);
     BID_RETURN (res);
-
   }
 
 }
@@ -942,10 +1001,18 @@ int exponent_x, exponent_y, bin_index, bin_expon, diff_expon, ed2,
   digits_q, amount;
 int nzeros, i, j, k, d5, done = 0;
 unsigned rmode;
+int old_rm, rm_changed=0;
+
 #ifdef UNCHANGED_BINARY_STATUS_FLAGS
 fexcept_t binaryflags = 0;
 #endif
 
+// Set it to round-to-nearest (if different)
+if ((old_rm=fegetround()) != FE_TONEAREST) {
+  rm_changed=1;
+  fesetround(FE_TONEAREST);
+}
+
 valid_y = unpack_BID64 (&sign_y, &exponent_y, &CY.w[0], (y));
 
 	// unpack arguments, check for NaN or Infinity
@@ -964,7 +1031,9 @@ if (!unpack_BID128_value (&sign_x, &exponent_x, &CX, x)) {
       amount = recip_scale[18];
       __shr_128 (Tmp, Qh, amount);
       res = (CX.w[1] & 0xfc00000000000000ull) | Tmp.w[0];
-    BID_RETURN (res);
+      // restore the rounding mode back if it has been changed
+      if (rm_changed) fesetround(old_rm);
+      BID_RETURN (res);
   }
   // x is Infinity?
   if ((x.w[1] & 0x7800000000000000ull) == 0x7800000000000000ull) {
@@ -976,14 +1045,18 @@ if (!unpack_BID128_value (&sign_x, &exponent_x, &CX, x)) {
       __set_status_flags (pfpsf, INVALID_EXCEPTION);
 #endif
       res = 0x7c00000000000000ull;
+      // restore the rounding mode back if it has been changed
+      if (rm_changed) fesetround(old_rm);
+      BID_RETURN (res);
+    }
+    if (((y & 0x7c00000000000000ull) != 0x7c00000000000000ull)) {
+      // otherwise return +/-Inf
+      res =
+	((x.w[1] ^ (y)) & 0x8000000000000000ull) | 0x7800000000000000ull;
+      // restore the rounding mode back if it has been changed
+      if (rm_changed) fesetround(old_rm);
       BID_RETURN (res);
     }
-	if (((y & 0x7c00000000000000ull) != 0x7c00000000000000ull)) {
-    // otherwise return +/-Inf
-    res =
-      ((x.w[1] ^ (y)) & 0x8000000000000000ull) | 0x7800000000000000ull;
-    BID_RETURN (res);
-	}
   }
   // x is 0
   if (((y & INFINITY_MASK64) != INFINITY_MASK64) &&
@@ -993,17 +1066,21 @@ if (!unpack_BID128_value (&sign_x, &exponent_x, &CX, x)) {
 #endif
     // x=y=0, return NaN
     res = 0x7c00000000000000ull;
+    // restore the rounding mode back if it has been changed
+    if (rm_changed) fesetround(old_rm);
     BID_RETURN (res);
   }
   // return 0
   if (((y & 0x7800000000000000ull) != 0x7800000000000000ull)) {
-	  if (!CY.w[0]) {
+    if (!CY.w[0]) {
 #ifdef SET_STATUS_FLAGS
       __set_status_flags (pfpsf, INVALID_EXCEPTION);
 #endif
       res = 0x7c00000000000000ull;
+      // restore the rounding mode back if it has been changed
+      if (rm_changed) fesetround(old_rm);
       BID_RETURN (res);
-	  }
+    }
     exponent_x =
       exponent_x - exponent_y - DECIMAL_EXPONENT_BIAS_128 +
       (DECIMAL_EXPONENT_BIAS << 1);
@@ -1012,6 +1089,8 @@ if (!unpack_BID128_value (&sign_x, &exponent_x, &CX, x)) {
     else if (exponent_x < 0)
       exponent_x = 0;
     res = (sign_x ^ sign_y) | (((UINT64) exponent_x) << 53);
+    // restore the rounding mode back if it has been changed
+    if (rm_changed) fesetround(old_rm);
     BID_RETURN (res);
   }
 }
@@ -1025,12 +1104,16 @@ if (!valid_y) {
     if ((y & SNAN_MASK64) == SNAN_MASK64)	// sNaN
       __set_status_flags (pfpsf, INVALID_EXCEPTION);
 #endif
+    // restore the rounding mode back if it has been changed
+    if (rm_changed) fesetround(old_rm);
     BID_RETURN (CY.w[0] & QUIET_MASK64);
   }
   // y is Infinity?
   if (((y) & 0x7800000000000000ull) == 0x7800000000000000ull) {
     // return +/-0
     res = sign_x ^ sign_y;
+    // restore the rounding mode back if it has been changed
+    if (rm_changed) fesetround(old_rm);
     BID_RETURN (res);
   }
   // y is 0, return +/-Inf
@@ -1039,6 +1122,8 @@ if (!valid_y) {
 #ifdef SET_STATUS_FLAGS
   __set_status_flags (pfpsf, ZERO_DIVIDE_EXCEPTION);
 #endif
+  // restore the rounding mode back if it has been changed
+  if (rm_changed) fesetround(old_rm);
   BID_RETURN (res);
 }
 #ifdef UNCHANGED_BINARY_STATUS_FLAGS
@@ -1103,6 +1188,8 @@ if (__unsigned_compare_gt_128 (CY, CX)) {
 #ifdef UNCHANGED_BINARY_STATUS_FLAGS
       (void) fesetexceptflag (&binaryflags, FE_ALL_FLAGS);
 #endif
+      // restore the rounding mode back if it has been changed
+      if (rm_changed) fesetround(old_rm);
       BID_RETURN (res);
     }
 
@@ -1159,102 +1246,104 @@ if (!done) {
 #endif
 #ifndef LEAVE_TRAILING_ZEROS
     // check whether result is exact
-  {
-	  if(!done) {
-    // check whether CX, CY are short
-    if (!CX.w[1] && !CY.w[1] && (CX.w[0] <= 1024) && (CY.w[0] <= 1024)) {
-      i = (int) CY.w[0] - 1;
-      j = (int) CX.w[0] - 1;
-      // difference in powers of 2 factors for Y and X
-      nzeros = ed2 - factors[i][0] + factors[j][0];
-      // difference in powers of 5 factors
-      d5 = ed2 - factors[i][1] + factors[j][1];
-      if (d5 < nzeros)
-		nzeros = d5;
-      // get P*(2^M[extra_digits])/10^extra_digits
-      __mul_128x128_high (Qh, CQ, reciprocals10_128[nzeros]);
-      //__mul_128x128_to_256(P256, CQ, reciprocals10_128[nzeros]);Qh.w[1]=P256.w[3];Qh.w[0]=P256.w[2];
-
-      // now get P/10^extra_digits: shift Q_high right by M[extra_digits]-128
-      amount = recip_scale[nzeros];
-      __shr_128_long (CQ, Qh, amount);
-
-      diff_expon += nzeros;
-    } else {
-      // decompose Q as Qh*10^17 + Ql
-      //T128 = reciprocals10_128[17];
-      Q_low = CQ.w[0];
-
-      {
-	tdigit[0] = Q_low & 0x3ffffff;
-	tdigit[1] = 0;
-	QX = Q_low >> 26;
-	QX32 = QX;
-	nzeros = 0;
-
-	for (j = 0; QX32; j++, QX32 >>= 7) {
-	  k = (QX32 & 127);
-	  tdigit[0] += convert_table[j][k][0];
-	  tdigit[1] += convert_table[j][k][1];
-	  if (tdigit[0] >= 100000000) {
-	    tdigit[0] -= 100000000;
-	    tdigit[1]++;
-	  }
-	}
-
-	if (tdigit[1] >= 100000000) {
-	  tdigit[1] -= 100000000;
-	  if (tdigit[1] >= 100000000)
-	    tdigit[1] -= 100000000;
-	}
-
-	digit = tdigit[0];
-	if (!digit && !tdigit[1])
-	  nzeros += 16;
-	else {
-	  if (!digit) {
-	    nzeros += 8;
-	    digit = tdigit[1];
-	  }
-	  // decompose digit
-	  PD = (UINT64) digit *0x068DB8BBull;
-	  digit_h = (UINT32) (PD >> 40);
-	  digit_low = digit - digit_h * 10000;
-
-	  if (!digit_low)
-	    nzeros += 4;
-	  else
-	    digit_h = digit_low;
-
-	  if (!(digit_h & 1))
-	    nzeros +=
-	      3 & (UINT32) (packed_10000_zeros[digit_h >> 3] >>
-			    (digit_h & 7));
-	}
-
-	if (nzeros) {
+    {
+      if(!done) {
+	// check whether CX, CY are short
+	if (!CX.w[1] && !CY.w[1] && (CX.w[0] <= 1024) && (CY.w[0] <= 1024)) {
+	  i = (int) CY.w[0] - 1;
+	  j = (int) CX.w[0] - 1;
+	  // difference in powers of 2 factors for Y and X
+	  nzeros = ed2 - factors[i][0] + factors[j][0];
+	  // difference in powers of 5 factors
+	  d5 = ed2 - factors[i][1] + factors[j][1];
+	  if (d5 < nzeros)
+	    nzeros = d5;
 	  // get P*(2^M[extra_digits])/10^extra_digits
 	  __mul_128x128_high (Qh, CQ, reciprocals10_128[nzeros]);
+	  //__mul_128x128_to_256(P256, CQ, reciprocals10_128[nzeros]);Qh.w[1]=P256.w[3];Qh.w[0]=P256.w[2];
 
 	  // now get P/10^extra_digits: shift Q_high right by M[extra_digits]-128
 	  amount = recip_scale[nzeros];
-	  __shr_128 (CQ, Qh, amount);
-	}
-	diff_expon += nzeros;
+	  __shr_128_long (CQ, Qh, amount);
 
+	  diff_expon += nzeros;
+	} else {
+	  // decompose Q as Qh*10^17 + Ql
+	  //T128 = reciprocals10_128[17];
+	  Q_low = CQ.w[0];
+
+	  {
+	    tdigit[0] = Q_low & 0x3ffffff;
+	    tdigit[1] = 0;
+	    QX = Q_low >> 26;
+	    QX32 = QX;
+	    nzeros = 0;
+
+	    for (j = 0; QX32; j++, QX32 >>= 7) {
+	      k = (QX32 & 127);
+	      tdigit[0] += convert_table[j][k][0];
+	      tdigit[1] += convert_table[j][k][1];
+	      if (tdigit[0] >= 100000000) {
+		tdigit[0] -= 100000000;
+		tdigit[1]++;
+	      }
+	    }
+
+	    if (tdigit[1] >= 100000000) {
+	      tdigit[1] -= 100000000;
+	      if (tdigit[1] >= 100000000)
+		tdigit[1] -= 100000000;
+	    }
+
+	    digit = tdigit[0];
+	    if (!digit && !tdigit[1])
+	      nzeros += 16;
+	    else {
+	      if (!digit) {
+		nzeros += 8;
+		digit = tdigit[1];
+	      }
+	      // decompose digit
+	      PD = (UINT64) digit *0x068DB8BBull;
+	      digit_h = (UINT32) (PD >> 40);
+	      digit_low = digit - digit_h * 10000;
+
+	      if (!digit_low)
+		nzeros += 4;
+	      else
+		digit_h = digit_low;
+
+	      if (!(digit_h & 1))
+		nzeros +=
+		  3 & (UINT32) (packed_10000_zeros[digit_h >> 3] >>
+				(digit_h & 7));
+	    }
+	
+	    if (nzeros) {
+	      // get P*(2^M[extra_digits])/10^extra_digits
+	      __mul_128x128_high (Qh, CQ, reciprocals10_128[nzeros]);
+
+	      // now get P/10^extra_digits: shift Q_high right by M[extra_digits]-128
+	      amount = recip_scale[nzeros];
+	      __shr_128 (CQ, Qh, amount);
+	    }
+	    diff_expon += nzeros;
+
+	  }
+	}
+      }
+      if(diff_expon>=0){
+	res =
+	  fast_get_BID64_check_OF (sign_x ^ sign_y, diff_expon, CQ.w[0],
+				   rnd_mode, pfpsf);
+#ifdef UNCHANGED_BINARY_STATUS_FLAGS
+	(void) fesetexceptflag (&binaryflags, FE_ALL_FLAGS);
+#endif
+        // restore the rounding mode back if it has been changed
+	if (rm_changed) fesetround(old_rm);
+	BID_RETURN (res);
       }
     }
-	  }
-	if(diff_expon>=0){
-    res =
-      fast_get_BID64_check_OF (sign_x ^ sign_y, diff_expon, CQ.w[0],
-			       rnd_mode, pfpsf);
-#ifdef UNCHANGED_BINARY_STATUS_FLAGS
-    (void) fesetexceptflag (&binaryflags, FE_ALL_FLAGS);
-#endif
-    BID_RETURN (res);
-	}
-  }
 #endif
 
   if (diff_expon >= 0) {
@@ -1337,6 +1426,8 @@ if (!done) {
 #ifdef UNCHANGED_BINARY_STATUS_FLAGS
     (void) fesetexceptflag (&binaryflags, FE_ALL_FLAGS);
 #endif
+    // restore the rounding mode back if it has been changed
+    if (rm_changed) fesetround(old_rm);
     BID_RETURN (res);
   } else {
     // UF occurs
@@ -1353,8 +1444,9 @@ if (!done) {
 #ifdef UNCHANGED_BINARY_STATUS_FLAGS
     (void) fesetexceptflag (&binaryflags, FE_ALL_FLAGS);
 #endif
+    // restore the rounding mode back if it has been changed
+    if (rm_changed) fesetround(old_rm);
     BID_RETURN (res);
-
   }
 
 }
@@ -1379,10 +1471,17 @@ int exponent_x, exponent_y, bin_index, bin_expon, diff_expon, ed2,
   digits_q, amount;
 int nzeros, i, j, k, d5, done = 0;
 unsigned rmode;
+int old_rm, rm_changed=0;
 #ifdef UNCHANGED_BINARY_STATUS_FLAGS
 fexcept_t binaryflags = 0;
 #endif
 
+// Set it to round-to-nearest (if different)
+if ((old_rm=fegetround()) != FE_TONEAREST) {
+  rm_changed=1;
+  fesetround(FE_TONEAREST);
+}
+
 valid_y = unpack_BID128_value (&sign_y, &exponent_y, &CY, y);
 
 	// unpack arguments, check for NaN or Infinity
@@ -1401,7 +1500,9 @@ if (!unpack_BID128_value (&sign_x, &exponent_x, &CX, x)) {
       amount = recip_scale[18];
       __shr_128 (Tmp, Qh, amount);
       res = (CX.w[1] & 0xfc00000000000000ull) | Tmp.w[0];
-    BID_RETURN (res);
+      // restore the rounding mode back if it has been changed
+      if (rm_changed) fesetround(old_rm);
+      BID_RETURN (res);
   }
   // x is Infinity?
   if ((x.w[1] & 0x7800000000000000ull) == 0x7800000000000000ull) {
@@ -1413,15 +1514,19 @@ if (!unpack_BID128_value (&sign_x, &exponent_x, &CX, x)) {
       __set_status_flags (pfpsf, INVALID_EXCEPTION);
 #endif
       res = 0x7c00000000000000ull;
+      // restore the rounding mode back if it has been changed
+      if (rm_changed) fesetround(old_rm);
+      BID_RETURN (res);
+    }
+    if (((y.w[1] & 0x7c00000000000000ull) != 0x7c00000000000000ull)) {
+      // otherwise return +/-Inf
+      res =
+	((x.w[1] ^ y.
+	  w[1]) & 0x8000000000000000ull) | 0x7800000000000000ull;
+      // restore the rounding mode back if it has been changed
+      if (rm_changed) fesetround(old_rm);
       BID_RETURN (res);
     }
-	if (((y.w[1] & 0x7c00000000000000ull) != 0x7c00000000000000ull)) {
-    // otherwise return +/-Inf
-    res =
-      ((x.w[1] ^ y.
-	w[1]) & 0x8000000000000000ull) | 0x7800000000000000ull;
-    BID_RETURN (res);
-	}
   }
   // x is 0
   if (((y.w[1] & 0x7800000000000000ull) != 0x7800000000000000ull)) {
@@ -1431,6 +1536,8 @@ if (!unpack_BID128_value (&sign_x, &exponent_x, &CX, x)) {
 #endif
     // x=y=0, return NaN
     res = 0x7c00000000000000ull;
+    // restore the rounding mode back if it has been changed
+    if (rm_changed) fesetround(old_rm);
     BID_RETURN (res);
   }
   // return 0
@@ -1441,6 +1548,8 @@ if (!unpack_BID128_value (&sign_x, &exponent_x, &CX, x)) {
   else if (exponent_x < 0)
     exponent_x = 0;
   res |= (((UINT64) exponent_x) << 53);
+  // restore the rounding mode back if it has been changed
+  if (rm_changed) fesetround(old_rm);
   BID_RETURN (res);
   }
 }
@@ -1460,12 +1569,16 @@ if (!valid_y) {
       amount = recip_scale[18];
       __shr_128 (Tmp, Qh, amount);
       res = (CY.w[1] & 0xfc00000000000000ull) | Tmp.w[0];
-    BID_RETURN (res);
+      // restore the rounding mode back if it has been changed
+      if (rm_changed) fesetround(old_rm);
+      BID_RETURN (res);
   }
   // y is Infinity?
   if ((y.w[1] & 0x7800000000000000ull) == 0x7800000000000000ull) {
     // return +/-0
     res = sign_x ^ sign_y;
+    // restore the rounding mode back if it has been changed
+    if (rm_changed) fesetround(old_rm);
     BID_RETURN (res);
   }
   // y is 0, return +/-Inf
@@ -1474,6 +1587,8 @@ if (!valid_y) {
 #ifdef SET_STATUS_FLAGS
   __set_status_flags (pfpsf, ZERO_DIVIDE_EXCEPTION);
 #endif
+  // restore the rounding mode back if it has been changed
+  if (rm_changed) fesetround(old_rm);
   BID_RETURN (res);
 }
 #ifdef UNCHANGED_BINARY_STATUS_FLAGS
@@ -1536,6 +1651,8 @@ if (__unsigned_compare_gt_128 (CY, CX)) {
 #ifdef UNCHANGED_BINARY_STATUS_FLAGS
       (void) fesetexceptflag (&binaryflags, FE_ALL_FLAGS);
 #endif
+      // restore the rounding mode back if it has been changed
+      if (rm_changed) fesetround(old_rm);
       BID_RETURN (res);
     }
 
@@ -1594,100 +1711,102 @@ if (!done) {
 #ifndef LEAVE_TRAILING_ZEROS
     // check whether result is exact
   {
-	  if(!done) {
-    // check whether CX, CY are short
-    if (!CX.w[1] && !CY.w[1] && (CX.w[0] <= 1024) && (CY.w[0] <= 1024)) {
-      i = (int) CY.w[0] - 1;
-      j = (int) CX.w[0] - 1;
-      // difference in powers of 2 factors for Y and X
-      nzeros = ed2 - factors[i][0] + factors[j][0];
-      // difference in powers of 5 factors
-      d5 = ed2 - factors[i][1] + factors[j][1];
-      if (d5 < nzeros)
-	nzeros = d5;
-      // get P*(2^M[extra_digits])/10^extra_digits
-      __mul_128x128_high (Qh, CQ, reciprocals10_128[nzeros]);
-      //__mul_128x128_to_256(P256, CQ, reciprocals10_128[nzeros]);Qh.w[1]=P256.w[3];Qh.w[0]=P256.w[2];
-
-      // now get P/10^extra_digits: shift Q_high right by M[extra_digits]-128
-      amount = recip_scale[nzeros];
-      __shr_128_long (CQ, Qh, amount);
-
-      diff_expon += nzeros;
-    } else {
-      // decompose Q as Qh*10^17 + Ql
-      //T128 = reciprocals10_128[17];
-      Q_low = CQ.w[0];
-
-      {
-	tdigit[0] = Q_low & 0x3ffffff;
-	tdigit[1] = 0;
-	QX = Q_low >> 26;
-	QX32 = QX;
-	nzeros = 0;
-
-	for (j = 0; QX32; j++, QX32 >>= 7) {
-	  k = (QX32 & 127);
-	  tdigit[0] += convert_table[j][k][0];
-	  tdigit[1] += convert_table[j][k][1];
-	  if (tdigit[0] >= 100000000) {
-	    tdigit[0] -= 100000000;
-	    tdigit[1]++;
-	  }
-	}
-
-	if (tdigit[1] >= 100000000) {
-	  tdigit[1] -= 100000000;
-	  if (tdigit[1] >= 100000000)
-	    tdigit[1] -= 100000000;
-	}
-
-	digit = tdigit[0];
-	if (!digit && !tdigit[1])
-	  nzeros += 16;
-	else {
-	  if (!digit) {
-	    nzeros += 8;
-	    digit = tdigit[1];
-	  }
-	  // decompose digit
-	  PD = (UINT64) digit *0x068DB8BBull;
-	  digit_h = (UINT32) (PD >> 40);
-	  digit_low = digit - digit_h * 10000;
-
-	  if (!digit_low)
-	    nzeros += 4;
-	  else
-	    digit_h = digit_low;
-
-	  if (!(digit_h & 1))
-	    nzeros +=
-	      3 & (UINT32) (packed_10000_zeros[digit_h >> 3] >>
-			    (digit_h & 7));
-	}
-
-	if (nzeros) {
-	  // get P*(2^M[extra_digits])/10^extra_digits
-	  __mul_128x128_high (Qh, CQ, reciprocals10_128[nzeros]);
-
-	  // now get P/10^extra_digits: shift Q_high right by M[extra_digits]-128
-	  amount = recip_scale[nzeros];
-	  __shr_128 (CQ, Qh, amount);
-	}
+    if(!done) {
+      // check whether CX, CY are short
+      if (!CX.w[1] && !CY.w[1] && (CX.w[0] <= 1024) && (CY.w[0] <= 1024)) {
+	i = (int) CY.w[0] - 1;
+	j = (int) CX.w[0] - 1;
+	// difference in powers of 2 factors for Y and X
+	nzeros = ed2 - factors[i][0] + factors[j][0];
+	// difference in powers of 5 factors
+	d5 = ed2 - factors[i][1] + factors[j][1];
+	if (d5 < nzeros)
+	  nzeros = d5;
+	// get P*(2^M[extra_digits])/10^extra_digits
+	__mul_128x128_high (Qh, CQ, reciprocals10_128[nzeros]);
+	//__mul_128x128_to_256(P256, CQ, reciprocals10_128[nzeros]);Qh.w[1]=P256.w[3];Qh.w[0]=P256.w[2];
+	
+	// now get P/10^extra_digits: shift Q_high right by M[extra_digits]-128
+	amount = recip_scale[nzeros];
+	__shr_128_long (CQ, Qh, amount);
+	
 	diff_expon += nzeros;
+      } else {
+	// decompose Q as Qh*10^17 + Ql
+	//T128 = reciprocals10_128[17];
+	Q_low = CQ.w[0];
+      
+	{
+	  tdigit[0] = Q_low & 0x3ffffff;
+	  tdigit[1] = 0;
+	  QX = Q_low >> 26;
+	  QX32 = QX;
+	  nzeros = 0;
 
+	  for (j = 0; QX32; j++, QX32 >>= 7) {
+	    k = (QX32 & 127);
+	    tdigit[0] += convert_table[j][k][0];
+	    tdigit[1] += convert_table[j][k][1];
+	    if (tdigit[0] >= 100000000) {
+	      tdigit[0] -= 100000000;
+	      tdigit[1]++;
+	    }
+	  }
+
+	  if (tdigit[1] >= 100000000) {
+	    tdigit[1] -= 100000000;
+	    if (tdigit[1] >= 100000000)
+	      tdigit[1] -= 100000000;
+	  }
+
+	  digit = tdigit[0];
+	  if (!digit && !tdigit[1])
+	    nzeros += 16;
+	  else {
+	    if (!digit) {
+	      nzeros += 8;
+	      digit = tdigit[1];
+	    }
+	    // decompose digit
+	    PD = (UINT64) digit *0x068DB8BBull;
+	    digit_h = (UINT32) (PD >> 40);
+	    digit_low = digit - digit_h * 10000;
+
+	    if (!digit_low)
+	      nzeros += 4;
+	    else
+	      digit_h = digit_low;
+
+	    if (!(digit_h & 1))
+	      nzeros +=
+		3 & (UINT32) (packed_10000_zeros[digit_h >> 3] >>
+			      (digit_h & 7));
+	  }
+
+	  if (nzeros) {
+	    // get P*(2^M[extra_digits])/10^extra_digits
+	    __mul_128x128_high (Qh, CQ, reciprocals10_128[nzeros]);
+
+	    // now get P/10^extra_digits: shift Q_high right by M[extra_digits]-128
+	    amount = recip_scale[nzeros];
+	    __shr_128 (CQ, Qh, amount);
+	  }
+	  diff_expon += nzeros;
+
+	}
       }
     }
-	  }
-	if(diff_expon>=0){
-    res =
-      fast_get_BID64_check_OF (sign_x ^ sign_y, diff_expon, CQ.w[0],
-			       rnd_mode, pfpsf);
+    if(diff_expon>=0){
+      res =
+	fast_get_BID64_check_OF (sign_x ^ sign_y, diff_expon, CQ.w[0],
+				 rnd_mode, pfpsf);
 #ifdef UNCHANGED_BINARY_STATUS_FLAGS
-    (void) fesetexceptflag (&binaryflags, FE_ALL_FLAGS);
+      (void) fesetexceptflag (&binaryflags, FE_ALL_FLAGS);
 #endif
-    BID_RETURN (res);
-	}
+      // restore the rounding mode back if it has been changed
+      if (rm_changed) fesetround(old_rm);
+      BID_RETURN (res);
+    }
   }
 #endif
 
@@ -1772,6 +1891,8 @@ if (!done) {
 #ifdef UNCHANGED_BINARY_STATUS_FLAGS
     (void) fesetexceptflag (&binaryflags, FE_ALL_FLAGS);
 #endif
+    // restore the rounding mode back if it has been changed
+    if (rm_changed) fesetround(old_rm);
     BID_RETURN (res);
   } else {
     // UF occurs
@@ -1788,8 +1909,9 @@ if (!done) {
 #ifdef UNCHANGED_BINARY_STATUS_FLAGS
     (void) fesetexceptflag (&binaryflags, FE_ALL_FLAGS);
 #endif
+    // restore the rounding mode back if it has been changed
+    if (rm_changed) fesetround(old_rm);
     BID_RETURN (res);
-
   }
 
 }
